import request from '@/utils/request';

/**
 * 分页查询商品
 * @param params 查询条件
 */
export async function pageGoods(params) {
  const res = await request.get('/sylive/goods/page', {
    params
  });
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询商品列表
 * @param params 查询条件
 */
export async function listGoods(params) {
  const res = await request.get('/sylive/goods/items', {
    params
  });
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询商品
 * @param id 商品id
 */
export async function getGoods(id) {
  const res = await request.get('/sylive/goods/' + id);
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加商品
 * @param data 商品信息
 */
export async function addGoods(data) {
  const res = await request.post('/sylive/goods', data);
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改商品
 * @param data 商品信息
 */
export async function updateGoods(data) {
  const res = await request.put('/sylive/goods', data);
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改商品状态
 * @param itemId 商品id
 * @param status 状态
 */
export async function updateGoodsStatus(itemId, status) {
  const res = await request.put('/sylive/goods/status', {
    itemId,
    status
  });
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除商品
 * @param id 商品id
 */
export async function removeGoods(id) {
  return removeGoodss([id]);
}

/**
 * 批量删除活动
 * @param ids 商品id集合
 */
export async function removeGoodss(ids) {
  const res = await request.delete('/sylive/goods/batch', {
    data: { ids }
  });
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
